=== src/common/boot_picoboot_headers/CMakeLists.txt ===
add_library(boot_picoboot_headers INTERFACE)
target_include_directories(boot_picoboot_headers SYSTEM INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include)
