=== src/rp2_common/hardware_dcp/CMakeLists.txt ===
pico_simple_hardware_headers_only_target(dcp)
