=== src/rp2_common/hardware_dma/CMakeLists.txt ===
pico_simple_hardware_target(dma)
pico_mirrored_target_link_libraries(hardware_dma INTERFACE hardware_claim)
