=== debian/changelog ===
pico-sdk (2.1.1-1) unstable; urgency=medium

  * debian/control: demote picotool to Recommends
  * debian/tests/control: add picotool to Depends
  * debian/control: wrap-and-sort -astb
  * New upstream version 2.1.1 (closes: #1100331)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 17 Mar 2025 09:25:49 +0100
