=== debian/control ===
Source: pico-sdk
Section: libdevel
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Homepage: https://github.com/raspberrypi/pico-sdk/issues
Vcs-Browser: https://salsa.debian.org/debian/pico-sdk
Vcs-Git: https://salsa.debian.org/debian/pico-sdk.git
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Build-Depends-Indep:
 doxygen,
 gcc-arm-none-eabi,
 graphviz,
 libnewlib-arm-none-eabi,
 libstdc++-arm-none-eabi-newlib,
 python3,
 tinyusb-source,

Package: pico-sdk-source
Architecture: all
Depends:
 cmake,
 gcc-arm-none-eabi,
 libnewlib-arm-none-eabi,
 libstdc++-arm-none-eabi-newlib,
 pioasm,
 python3,
 tinyusb-source,
 ${misc:Depends},
Recommends:
 picotool (>= 2.0),
Multi-Arch: foreign
Description: headers and libraries to write programs for RP2040-based devices
 The Raspberry Pi Pico SDK provides the headers, libraries and build system
 necessary to write programs for the RP2040-based devices such as the Raspberry
 Pi Pico in C, C++ or assembly language.
 .
 The SDK is designed to provide an API and programming environment that is
 familiar both to non-embedded C developers and embedded C developers alike. A
 single program runs on the device at a time and starts with a conventional
 main() method. Standard C/C++ libraries are supported along with C level
 libraries/APIs for accessing all of the RP2040's hardware include PIO.
 .
 Additionally the SDK provides higher level libraries for dealing with timers,
 synchronization, USB (TinyUSB) and multi-core programming along with various
 utilities.
 .
 The SDK can be used to build anything from simple applications, to fully
 fledged runtime environments such as MicroPython, to low level software such
 as RP2040's on-chip bootrom itself.

Package: pioasm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: Assemble file of PIO program(s) for use in applications
 For the development of applications for the Raspberry Pi with the Pico SDK.
 Available output formats are c-sdk, python, hex, ada and go. The default
 output is c-skd.
